const lunr = window.lunr;

// index for lunr
let index = lunr(function() {
    this.ref('id')
    this.field('title', {boost: 10})
    this.field('product')
    this.field('link')
    this.field('revision')
    this.field('excerpt')
    this.field('content')

    for (let key in window.store) {
        this.add({
          'id': key,
          'title': window.store[key].title,
          'product': window.store[key].product,
          'link': window.store[key].link,
          'revision': window.store[key].revision,
          'excerpt': window.store[key].excerpt,
          'content': window.store[key].content
        })
    }
});

const searchfield = document.querySelector(".searchField")
const resultsfield = document.querySelector('#searchcontainer')


// query via url
const parser = document.createElement('a')
parser.href = window.location.href

// offline searching

searchfield && searchfield.addEventListener('keyup', function(event) {
    event.preventDefault()
    const query = this.value
    returnResults(query)
  });


// see if we want to search
if(parser.href.includes('=')) {
  const searchquery = decodeURIComponent(parser.href.substring(parser.href.indexOf('=') + 1))
  var searchqueryFix = String(searchquery).replace(new RegExp("\\+","g"),' ')
  console.log('Searching: "' + searchqueryFix + '"...')
  document.querySelector("#searchInput").value = searchqueryFix;
  returnResults(searchqueryFix);
}

// do the search
function returnResults(query) {
  const result = index.search(query)
  if (query == ""){
    resultsfield.innerHTML = ``;
  }
  else if (result.length == 0) {
    resultsfield.innerHTML = `
      <div class="search-fail"><p>Hm... we can't seem to find what you're looking for. Please try a different search.</p></div>
    `
  } else {
    resultsfield.innerHTML = ``;
  for (let item of result) {
        var pageResult = window.store[item.ref];
        var excerpt = juryRigMd(pageResult.excerpt)
        const searchItem = document.createElement('div')
        searchItem.className = 'search-result'
        searchItem.innerHTML = `
        <h3><a href="${pageResult.link}">${pageResult.title}</a></h3>
        <p>${excerpt}</p>`
        resultsfield.appendChild(searchItem)
      }}
}

// shoehorning in some markdown fixes. There is almost definitely a better way to do this, but this works for now.

function juryRigMd(string){
  var mdIfy = string.replace(" **", " <strong>")
  const codeStart = new RegExp(" `","g");
  const codeEnd = new RegExp("`","g");
  const filepath = new RegExp("{:.filepath}","g")
  mdIfy = mdIfy.replace("** ", "</strong> ")
  mdIfy = mdIfy.replace("* ", "</em> ")
  mdIfy = mdIfy.replace(" *", " <em>")
//  mdIfy = mdIfy.replace(" ```", ' <code class="highlighter-rouge">')
//  mdIfy = mdIfy.replace("```", ' </code>')
  mdIfy = mdIfy.replace(codeStart, ' <code class="highlighter-rouge">')
  mdIfy = mdIfy.replace(codeEnd, '</code> ')
  mdIfy = mdIfy.replace("`:", '</code> ')
  mdIfy = mdIfy.replace("`-", '</code> ')
  mdIfy = mdIfy.replace("#######", 'Heading: ') // I know this is not efficient.
  mdIfy = mdIfy.replace("######", 'Heading: ')
  mdIfy = mdIfy.replace("#####", 'Heading: ')
  mdIfy = mdIfy.replace("####", 'Heading: ')
  mdIfy = mdIfy.replace("###", 'Heading: ')
  mdIfy = mdIfy.replace("##", 'Heading: ')
  mdIfy = mdIfy.replace("#", 'Heading: ')
  mdIfy = mdIfy.replace(filepath, "")
  return mdIfy
}
